//2002/04/23
#include	<stdio.h>
#include	<stdlib.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

/******************************************************************
	CUBEλ
			armno	No.
			num		CUBEֹ
			xyz		
			ypr		Ǿ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_set_cub(ARM armno, long num, float xyz[], float ypr[])
{
	long	ldmy;
	long	i;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}


	ldmy = (long)	EV_SET_CUB;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	num;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	for(i=0;i<3;i++){
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.xyz[i]),&(xyz[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.ypr[i]),&(ypr[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT))){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	CUBEζ
			armno	No.
			num		CUBEֹ
			mod		1:Ͷ
					2:ǾͶ
					3:濴

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_get_cub(ARM armno, long num, long mod)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_GET_CUB;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	num;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	mod;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT))){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	CUBEĹ
			armno	No.
			num	CUBEֹ
			xyz	줾դĹ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_cub_len(ARM armno, long num, float xyz[])
{
	long	ldmy;
	long	i;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_CUB_LEN;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	num;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	for(i=0;i<3;i++){
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.xyz[i]),&(xyz[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT))){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	CUBE̾Ĥ
			armno		No.
			num		CUBEֹ
			name		CUBE̾

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_cub_cmt(ARM armno, long num, char*	name)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_CUB_CMT;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	num;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	name[32]='\0';
	if(strlen(name)<32){
		st=pa_mem_blk((long)armno,&(_comuni->hd.bse.pkt[0]),name,(size_t)(strlen(name)+1),2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
	}
	else{
		st=pa_mem_blk((long)armno,&(_comuni->hd.bse.pkt[0]),name,(size_t)32,2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	CUBEκ
			armno		No.
			num		CUBEֹ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_del_cub(ARM armno, long num)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_DEL_CUB;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	num;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	CUBEͭ/̵
			armno		No.
			num		CUBEֹ
			mod		1:ͭ
					0:̵

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_ena_cub(ARM armno, long num, long mod)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_ENA_CUB;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	num;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	mod;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	CUBE󻲾
			armno		No.
			num		CUBEֹ
			cub		CUBE

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_inf_cub(ARM armno, long num, CUBEP cub)
{
	long	ldmy;
	char	cmt[33];
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_INF_CUB;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	num;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);

	if( ERR_OK==(st=pam_get_err(armno)) ){
		pa_map_ctl(armno);
		if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(cub->ena),&(_comuni->hu.cub.ena),1)))		return(st);
		if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(cub->mod),&(_comuni->hu.cub.mod),1)))		return(st);
		if(ERR_OK!=(st=pa_cpy_flt((long)armno,&(cub->max[0]),&(_comuni->hu.cub.max[0]),1)))	return(st);
		if(ERR_OK!=(st=pa_cpy_flt((long)armno,&(cub->max[1]),&(_comuni->hu.cub.max[1]),1)))	return(st);
		if(ERR_OK!=(st=pa_cpy_flt((long)armno,&(cub->max[2]),&(_comuni->hu.cub.max[2]),1)))	return(st);
		if(ERR_OK!=(st=pa_cpy_flt((long)armno,&(cub->min[0]),&(_comuni->hu.cub.min[0]),1)))	return(st);
		if(ERR_OK!=(st=pa_cpy_flt((long)armno,&(cub->min[1]),&(_comuni->hu.cub.min[1]),1)))	return(st);
		if(ERR_OK!=(st=pa_cpy_flt((long)armno,&(cub->min[2]),&(_comuni->hu.cub.min[2]),1)))	return(st);
		
		if(ERR_OK!=(st=pa_mem_blk((long)armno,cmt,&(_comuni->hu.cub.cmt[0]),sizeof(_comuni->hu.cub.cmt),1)))	return(st);

		memcpy(cub->cmt,cmt,32);		
	}

	return pam_get_err(armno);
}
