/*

	PAlib other function (pa_etc.c)

*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>


#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

/**********************************************************
	-
			armno		No.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
***********************************************************/
DllExport long __stdcall pa_rst_ctl(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);										//S2-W2ֵΥ
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	ErrorResetEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

#define	BR	break

/******************************************************************
	顼å
			err			顼No.
			buf			å򥳥ԡХåե

			ERR_MES 	顼åʤ
			ERR_OK		OK
******************************************************************/
DllExport long __stdcall pa_err_mes(long err, char *buf)
{
	char	*str;
//
//	˥
//
	switch(err){
	case ERR_OK:		str=" ";BR;

	/*ư顼(PAlibФ)*/
	case ERR_FILE:		str="-1 ꤵ줿եϤޤ";BR;
	case ERR_READ:		str="-2 եɤ߹߼";BR;
	case ERR_WRITE:		str="-3 ե񤭹߼";BR;
	case ERR_INT:		str="-4 486س߼";BR;
	case ERR_OPEN:		str="-5 pa_opn_arm()Ƥޤ";BR;
	case ERR_MALLOC:	str="-6 ݤ˼Ԥޤ";BR;
	case ERR_PRM:		str="-7	ϥѥ᡼ѹϤǤޤ";BR;
	case ERR_PNT:		str="-8 ǡλ٤ѥ᡼ϰϤۤƤޤ";BR;

	/*顼(PAlibФ)*/
	case ERR_ARM:	str="-20 ꤵ줿Ϥޤ";BR;
	case ERR_AXIS:	str="-21 ꤵ줿Ϥޤ";BR;
	case ERR_DRV:	str="-22 ꤵ줿ɥ饤ФϤޤ";BR;
	case ERR_PB:	str="-23 ץ쥤Хưְ̤äƤޤ";BR;
	case ERR_PD:	str="-24 ְ̤äƤޤ";BR;
	case ERR_PA:	str="-25 °ѹְ̤äƤޤ";BR;
	case ERR_PTN:	str="-26 ®٥ѥ-°ְͤäƤޤ";BR;
	case ERR_PT:	str="-27 ǡ׼ְ̤äƤޤ";BR;
	case ERR_PM:	str="-28 ְ̤äƤޤ";BR;
	case ERR_VT:	str="-29 ǥե®ѹְ̤äƤޤ";BR;
	case ERR_VM:	str="-30 ®⡼ɼְ̤äƤޤ";BR;
	case ERR_JM:	str="-31 Ĺ⡼ɼְ̤äƤޤ";BR;
	case ERR_JT:	str="-32 Ĺְ̤äƤޤ";BR;
	case ERR_MM:	str="-33 ɸü⡼ɼְ̤äƤޤ";BR;
	case ERR_DM:	str="-34 쥯ְ̤äƤޤ";BR;
	case ERR_DP:	str="-35 ǥϥݡȻְ꤬äƤޤ";BR;
	case ERR_DC:	str="-36 ǥϥְ꤬ͥäƤޤ";BR;
	case ERR_MES:	str="-37 --ɤƤޤ";BR;
	case ERR_BOARD:	str="-38 ǥϥܡɻְ꤬äƤޤ";BR;
	case ERR_DIO:	str="-39 ǥDIorDOְ꤬äƤޤ";BR;
	case ERR_PRJ:	str="-40 ץȤɤƤޤ";BR;

	/*WinRT顼(PAlibФ)*/
	case ERR_UNMAPMEMORY:	str="-100 WinRTUnMapMemoryǥ顼ȯޤ";BR;
	case ERR_UNMAPMEMORY2:	str="-101 WinRTUnMapMemory2ǥ顼ȯޤ";BR;
	case ERR_OPENDEVICE:	str="-200 WinRTOpenNamedDeviceǥ顼ȯޤ";BR;
	case ERR_CONFIG:		str="-201 WinRTGetFullConfigurationǥ顼ȯޤ";BR;
	case ERR_MAPMEMORY:		str="-300 WinRTMapMemoryǥ顼ȯޤ";BR;
	case ERR_MAPMEMORY2:	str="-301 WinRTMapMemory2ǥ顼ȯޤ";BR;

	/*˥󥰥顼*/

	case ERR_CANT_CPU:	str="-1000 楳ȥؤΥޤ";BR;
	case ERR_NON_EVNT:	str="-1001 եޥåȤȥޥɤޥåޤ";BR; 
	case ERR_CANT_EVNT:	str="-1002 ߤΥ⡼ɤǤбǤʤޥɤǤ";BR;
	case ERR_INVALD_EVNT:str="-1003 ޥɤ̵ ";BR;
	case ERR_NON_ARM:	str="-1004 ؼ줿ֹ椬ޤ";BR;
	case ERR_NON_ROB:	str="-1005 ROBեοɤɬ";BR;
	case ERR_NON_TOL:	str="-1006 TOLեοɤɬ";BR;

	case ERR_S1_VEL	:	str="-1010 ӣ®٥ݥ ";BR;
	case ERR_S2_VEL	:	str="-1011 ӣ®٥ݥ ";BR;
	case ERR_S3_VEL	:	str="-1012 ӣ®٥ݥ ";BR;
	case ERR_E1_VEL	:	str="-1013 ţ®٥ݥ ";BR;
	case ERR_E2_VEL	:	str="-1014 ţ®٥ݥ ";BR;
	case ERR_W1_VEL	:	str="-1015 ף®٥ݥ ";BR;
	case ERR_W2_VEL	:	str="-1016 ף®٥ݥ ";BR;
	case ERR_XYZ_VEL:	str="-1018 ü®٥ݥ ";BR;
	case ERR_YPR_VEL:	str="-1019 ü®٥ݥ ";BR;

	case ERR_S1_SAGL:	str="-1020 ӣ  ٥ݥ";BR;
	case ERR_S2_SAGL:	str="-1021 ӣ  ٥ݥ";BR;
	case ERR_S3_SAGL:	str="-1022 ӣ  ٥ݥ";BR;
	case ERR_E1_SAGL:	str="-1023 ţ  ٥ݥ";BR;
	case ERR_E2_SAGL:	str="-1024 ţ  ٥ݥ";BR;
	case ERR_W1_SAGL:	str="-1025 ף  ٥ݥ";BR;
	case ERR_W2_SAGL:	str="-1026 ף  ٥ݥ";BR;

	case ERR_S1_TAGL:	str="-1030 ӣ ɸ ٥ݥ";BR;
	case ERR_S2_TAGL:	str="-1031 ӣ ɸ ٥ݥ";BR;
	case ERR_S3_TAGL:	str="-1032 ӣ ɸ ٥ݥ";BR;
	case ERR_E1_TAGL:	str="-1033 ţ ɸ ٥ݥ";BR;
	case ERR_E2_TAGL:	str="-1034 ţ ɸ ٥ݥ";BR;
	case ERR_W1_TAGL:	str="-1035 ף ɸ ٥ݥ";BR;
	case ERR_W2_TAGL:	str="-1036 ף ɸ ٥ݥ";BR;

	case ERR_NOA_CLC:	str="-1038 NOA׻Ǥޤ";BR;
	case ERR_LNK_CTL:	str="-1039 Ϣ³ݸΤԲǽ";BR;
	case ERR_MEM_FULL:	str="-1040 γݤ˼ ";BR;
	case ERR_MIS_COMD:	str="-1041 ΥޥɤȯԤˤϼ³ɬ ";BR;
	case ERR_PB_CIR:    str="-1042 ߡ߸̤λ꤬äƤޤ";BR;
	case ERR_PB_NEXT:   str="-1043 Υݥ󥿤¸ߤޤ";BR;
	case ERR_PB_PRIV:   str="-1044 Υݥ󥿤¸ߤޤ";BR;
	case ERR_PB_END:    str="-1045 ץ쥤Хåǡݥνλ";BR;
	case ERR_PB_NULL:   str="-1046 ץ쥤Хåǡݥޤ";BR;
	case ERR_PB_REFER:  str="-1047 ץ쥤Хåǡݥθ˼Ԥޤ";BR;
	case ERR_PB_REPLACE:str="-1048 ץ쥤ޥɤȲᤷޤ";BR;
	case ERR_PB_PANIC:  str="-1049 ݥ󥿴";BR;

	case ERR_NOT_ENUGH: str="-1050 ɸͤԲǽΰǤʥĹ­ޤ";BR;
	case ERR_MIS_PARAM:	str="-1051 ѥ᡼ͤϰϤۤƤޤ";BR;
	case ERR_NOA_DAT:	str="-1060 ꤵ줿ΣϣŬڤǤ";BR;
	case ERR_PNT_ATR:	str="-1061 CP-κǸƼ°ǳޤ";BR;
	case ERR_PTP_DAT:	str="-1062 RMRCβưϰϤۤƤޤ";BR;
	case ERR_CP_LOGGING:str="-1063 CP-ǻѤǤޤ";BR;
	case ERR_FIFO_MAX:	str="-1064 ֿۤޤ      ";BR;
	case ERR_FIFO_ARC:	str="-1065 ߡ߸̤Ǥޤ  ";BR;

	case COVERS1:		str="-1070 ӣ ® ٥ݥ";BR;
	case COVERS2:		str="-1071 ӣ ® ٥ݥ";BR;
	case COVERS3:		str="-1072 ӣ ® ٥ݥ";BR;
	case COVERE1:		str="-1073 ţ ® ٥ݥ";BR;
	case COVERE2:		str="-1074 ţ ® ٥ݥ";BR;
	case COVERW1:		str="-1075 ף ® ٥ݥ";BR;
	case COVERW2:		str="-1076 ף ® ٥ݥ";BR;

	case ERR_MIS_VAL:   str="-1080 ͤ礭뤫ޤϾޤ";BR;
	case ERR_PNT_APP:	str="-1081 ƼǤϥץǤޤ";BR;

	case ERR_PLY_FOR:	str="-1098 ⡼Ϣ³žϤǤޤ";BR;
	case ERR_PLY_MOD:	str="-1099 Ƕ⡼ɤڤؤޤ";BR;
	case ERR_USE_TCH:	str="-1100 ⡼ɰʳǥƥåONǤޤ";BR;
	case ERR_ACT_DAT:	str="-1101 ꤵ줿Keyζǡޤ";BR;
	case ERR_CHG_KEY:	str="-1103 ǡKeyѹǤޤǤ";BR;

	case ERR_CUB_NUM:	str="-1200 ΰֹ楨顼";BR;
	case ERR_CUB_LEN:	str="-1201 Υ塼־ˤĹλ꤬Ǥޤ ̤Υ塼°äƤޤ";BR;
	case ERR_CUB_MAX:	str="-1202 Υ塼־ˤϾͶǤޤ ̤Υ塼°äƤޤ";BR;
	case ERR_CUB_MIN:	str="-1203 Υ塼־ˤϲͶǤޤ ̤Υ塼°äƤޤ";BR;
	case ERR_CUB_CTR:	str="-1205 Υ塼־ˤ濴ͶǤޤ ̤Υ塼°äƤޤ";BR;
	case ERR_CUB_PRM:	str="-1206 塼ѥ᡼Ǥ";BR;
	case ERR_CUB_SET:	str="-1207 Υ塼־ˤǤޤ ̤Υ塼°äƤޤ";BR;

	case ERR_PLY_KEY:	str="-1249 Key˻ꤷֹ椬äƤޤ";BR;

	case ERR_NON_KEY:	str="-1250 Keyǻꤵ줿ǡ˻ꤵ줿ID°Ϥޤ";BR;
	case ERR_NON_CID:	str="-1251 ꤵ줿JUMPäƤޤ";BR;
	case ERR_JMP_SET:	str="-1252 Keyǻꤵ줿ǡϤֹJUMPäƤޤ";BR;
	case ERR_NON_IDN:	str="-1253 ID°ǻؼ줿JUMPäƤޤ";BR;
	case ERR_JMP_NUM:	str="-1254 °˻ꤵƤJUMPȯǤޤ";BR;
	case ERR_JMP_ATR:	str="-1255 JUMPλѥ᡼˸꤬ޤ";BR;
	case ERR_KEY_ATR:	str="-1256 JUMPλѥ᡼˸꤬ޤ";BR;

	case ERR_SOC_TST:	str="-1300 åȤ˼";BR;
	case ERR_BND_TST:	str="-1311 åȤȥɥ쥹ΥХɤ˼";BR;
	case ERR_LSN_TST:	str="-1312 å˼";BR;
	case ERR_APT_TST:	str="-1313 ץȤ˼";BR;
	case ERR_SOC_SND:	str="-1314 å";BR;
	case ERR_SOC_BLK:	str="-1315 ̤";BR;
	case ERR_SOC_CLT:	str="-1316 ³饤Ȥ¿ޤ";BR;

	case ERR_PRM_DEV:	str="-1350 ѥ᡼ư®٤®٥ߥåͤĶƤޤѥ᡼ѹ̵Ǥ";BR;

	/*ž³ǽ顼ݡݡ䡡ʥ֥졼߾֡*/

	case ERR_OVER900:	str="-2017 ư˥-ĹRMRCư³Ĺ򥪡Сޤ";BR;

	case ERR_S1_AGL:	str="-2020 ӣ٥ݥ";BR;
	case ERR_S2_AGL:	str="-2021 ӣ٥ݥ";BR;
	case ERR_S3_AGL:	str="-2022 ӣ٥ݥ";BR;
	case ERR_E1_AGL:	str="-2023 ţ٥ݥ";BR;
	case ERR_E2_AGL:	str="-2024 ţ٥ݥ";BR;
	case ERR_W1_AGL:	str="-2025 ף٥ݥ";BR;
	case ERR_W2_AGL:	str="-2026 ף٥ݥ";BR;

	case DOVERS1:		str="-2030 ӣ 쥯 ٥ݥ";BR;
	case DOVERS2:		str="-2031 ӣ 쥯 ٥ݥ";BR;
	case DOVERS3:		str="-2032 ӣ 쥯 ٥ݥ";BR;
	case DOVERE1:		str="-2033 ţ 쥯 ٥ݥ";BR;
	case DOVERE2:		str="-2034 ţ 쥯 ٥ݥ";BR;
	case DOVERW1:		str="-2035 ף 쥯 ٥ݥ";BR;
	case DOVERW2:		str="-2036 ף 쥯 ٥ݥ";BR;

	case ERR_CANT_MOVE:	str="-2051 ֤߰ǤRMRCޤ";BR;

	case ERR_S1_REZ:	str="-2060 ӣ쥾к۾";BR;
	case ERR_S2_REZ:	str="-2061 ӣ쥾к۾";BR;
	case ERR_S3_REZ:	str="-2062 ӣ쥾к۾";BR;
	case ERR_E1_REZ:	str="-2063 ţ쥾к۾";BR;
	case ERR_E2_REZ:	str="-2064 ţ쥾к۾";BR;
	case ERR_W1_REZ:	str="-2065 ף쥾к۾";BR;
	case ERR_W2_REZ:	str="-2066 ף쥾к۾";BR;
/*
	쥾к۾ȤϡϤ쥾ͤȺϤͤ
	ϰϰʾˤʤä硣ɤߤܤε
*/
	case ERR_TIMEOUT:	str="-2070 ƻ֥-ФǼưߤޤ";BR;
	case ERR_SYNCOUT:	str="-2071 ɸͤޤãޤǤ";BR;

	case ERR_SYNC_S1:	str="-2080 ƼˤӣƱ۾";BR;
	case ERR_SYNC_S2:	str="-2081 ƼˤӣƱ۾";BR;
	case ERR_SYNC_S3:	str="-2082 ƼˤӣƱ۾";BR;
	case ERR_SYNC_E1:	str="-2083 ƼˤţƱ۾";BR;
	case ERR_SYNC_E2:	str="-2084 ƼˤţƱ۾";BR;
	case ERR_SYNC_W1:	str="-2085 ƼˤףƱ۾";BR;
	case ERR_SYNC_W2:	str="-2086 ƼˤףƱ۾";BR;
	case ERR_RMRC_X:	str="-2087 ңͣңˤؼƱ۾";BR;
	case ERR_RMRC_Y:	str="-2088 ңͣңˤټƱ۾";BR;
	case ERR_RMRC_Z:	str="-2089 ңͣңˤڼƱ۾";BR;
	case ERR_VELOCITY:	str="-2090 ®к۾";BR;
	case ERR_RMRC_YPR:	str="-2091 ңͣңˤк۾";BR;

	case ERR_CUB_INN:	str="-2100 塼֤˴Ĥޤ";BR;

	case ERR_ARM_ERR0:	str="-2200 ðưϷ³Ǥޤ";BR;
	case ERR_ARM_ERR1:	str="-2201 ðưϷ³Ǥޤ";BR;
	case ERR_ARM_ERR2:	str="-2202 ðưϷ³Ǥޤ";BR;

/*
	Ʊ۾Ȥϡɸͤȸͤкϰϰʾˤʤä硣
	ʥबưƤʤϤʤ٤Ƥ
*/

/*̿Ū顼ݡݡ䡡߾֡*/

	case ERR_POWER_ON:	str="-3000 椬ϤƤޤ";BR;
/*
	̿Ū顼ä,泫ϥޥɤȯԤ,¾
		  楳ޥɤȯԤȤΥ顼ȯ롣
*/
	case ERR_EM_CTL:	str="-3001 ߤƤޤ";BR;
	case ERR_ARC_SEND:	str="-3002 ͥå̿۾";BR;
	case ERR_DRV_TYP:	str="-3005 ܥɥ饤ФΥפѥ᡼ȰۤʤäƤޤ";BR;
	case ERR_FORCE_ON:	str="-3010 ǤϤޤ";BR;

	case ERR_DDD_STA:	str="-3070 ̿祵ܡʥޥ˥ơ۾";BR;
	case ERR_D11_STA:	str="-3071 ܥɥ饤Сʣӣ˥ơ۾";BR;
	case ERR_D12_STA:	str="-3072 ܥɥ饤Сʣӣ˥ơ۾";BR;
	case ERR_D21_STA:	str="-3073 ܥɥ饤Сʣӣ˥ơ۾";BR;
	case ERR_D22_STA:	str="-3074 ܥɥ饤Сʣţ˥ơ۾";BR;
	case ERR_D31_STA:	str="-3075 ܥɥ饤Сʣţ˥ơ۾";BR;
	case ERR_D32_STA:	str="-3076 ܥɥ饤Сʣף˥ơ۾";BR;
	case ERR_D41_STA:	str="-3077 ܥɥ饤Сʣף˥ơ۾";BR;

	case ERR_S_SUSPD:	str="-3091 ̿˳ϥޥ̿۾";BR;
	case ERR_E_SUSPD:	str="-3092 ̿˽λޥ̿۾";BR;
	case ERR_I_SUSPD:	str="-3093 ޥ̿۾";BR;

	case ERR_MOD_CTL:	str="-4000 ⡼ɴ۾";BR;
/*
	楳ޥȯԻ۾Ȥϡܥɥ饤ФФޥɤȯԸ
	ֿˤ̵ä硣
	ʥܥɥ饤Ф۾Ǥ롣
*/
/*ƥ२顼*/
	case DRV_MEM_ERR:	str="1 ͭ۾";BR;
	case EEP_ROM_ERR:	str="2 EEPROM۾";BR;
	case CPU_XXX_ERR:	str="3 CPU۾";BR;
	case ARC_NET_ERR:	str="4 ̿۾";BR;
	case VEL_SPN_ERR:	str="5 ®к۾";BR;
	case REZ_SPN_ERR:	str="6 쥾к۾";BR;
	case VEL_LIM_ERR:	str="7 ֥ߥåȰ۾";BR;
	case MTR_TRQ_ERR:	str="8 ⡼ȥ륯۾";BR;
	case IPM_XXX_ERR:	str="9 IPM۾";BR;
	case BRK_XXX_ERR:	str="10 ֥졼";BR;
	case REZ_001_ERR:	str="11 쥾Сʥ";BR;
	case REZ_002_ERR:	str="12 쥾Сʥ⡼";BR;
	case OVR_TRQ_ERR:	str="13 ή";BR;
	case OVR_VEL_ERR:	str="14 ®";BR;
	case DMS_XXX_ERR:	str="15 ǥåɥޥSW۾";BR;
	case CPU_NON_ERR:	str="16 ¾CPU۾";BR;

/* LANطΥ顼 */
	case -5001:			str="åȺ顼";		BR;
	case -5002:			str="å³顼";		BR;
	case -5003:			str="gethostbyname()顼";	BR;
	case -5004:			str="å顼";		BR;
	case -5005:			str="åWait Failed";		BR;
	case -5006:			str="åWait timeout";		BR;
	case -5007:			str="åerror event";		BR;
	case -5008:			str="å";				BR;
	case -5009:			str="åȼ顼";		BR;
	case -5010:			str="åȥǡ۾";		BR;
	case -5011:			str="åȥǡϢ֥顼";	BR;
    case -5012:			str="å̤³";			BR;


	default:
		str=NULL;
		sprintf(buf,"%ld ϿƤޤ.",err);
	}
	if( str ){
		strcpy(buf,str);
		return ERR_OK;
	}else
		return ERR_MES;
}
