/*


	PAlib joucyou control fuction


*/
#include	<stdio.h>
#include	<stdlib.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

/******************************************************************
	®
			armno		No.
			spd[]		,®٤[0]..[2]
					Ƽ®٤ϡ[0]..[6]
					ֻ®٤[0]..[5]
			
			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_odr_vel(ARM armno, float spd[])
{
	short	i;
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	7;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	for(i=0;i<7;i++){
		st=pa_cpy_flt((long)armno,&(_comuni->hd.mat.agl[i]),&(spd[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}

	ldmy = (long)	SendJSEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	Ĺmode
			armno		No.
			jm		mode

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_JM		JOUMODEְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_mod_jou(ARM armno, JOUMODE jm)
{
	long	ldmy;
	long	axsnum;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(axsnum),&(_comuni->hu.ard.axs),1);			//	༴
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if(axsnum==6){
		UnlockMutex((long)armno);
		return ERR_OK;
	}

	switch(jm){
	case JM_OFF:
		ldmy = (long)	JouCtrlEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case JM_ON:
		ldmy = (long)	JouCtrlEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case JM_S3ON:
		ldmy = (long)	JouCtrlEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case JM_S3DIV:
		ldmy = (long)	JouCtrlEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	4;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case JM_S3HOLD:
		ldmy = (long)	JouCtrlEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	8;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case JM_VSET:
		ldmy = (long)	RMRCStartEvent15;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0xfL;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[2]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0x7f;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case JM_SET:
		ldmy = (long)	RMRCStartEvent7;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0xfL;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[2]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0x7f;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case JM_RESET:
		ldmy = (long)	JouParamResetEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_JM;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}

	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	Ĺon/off
			armno		No.
			jt			ѥ᡼ư

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_JT		JOUTYPEְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_odr_jou(ARM armno, JOUTYPE jt)
{
	long	ldmy;
	float	fdmy;
	long	axsnum;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	st=pa_cpy_lng(	(long)armno,&(axsnum),&(_comuni->hu.ard.axs),1);			//	༴
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if(axsnum==6){
		UnlockMutex((long)armno);
		return ERR_OK;
	}


	ldmy = (long)	SendJSEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	7;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	switch(jt){
	case JT_RIGHT:
		fdmy = 1.0;
		break;
	case JT_HOLD:
		fdmy = 0.0;
		break;
	case JT_LEFT:
		fdmy = -1.0;
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_JT;
	}

	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[0]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

