#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<fcntl.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

#define	TextBufSize	80+1
#define	CRX	0x0a


/******************************************************************
	tool parm ѹ롣
			armno		No.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_set_tol(ARM armno, float d0, float d1, float d2, float d3)
{
	float	fdmy;
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	SetToolEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	5;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy = d0;						/* x ֥եå */
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.tol[0]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy = d1;						/* y ֥եå */
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.tol[1]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy = d2;						/* z ֥եå */
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.tol[2]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy = 0.0;						/**/
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.tol[3]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy = 0.0;						/**/
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.tol[4]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy = 0.0;						/**/
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.tol[5]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy = d3;						/* ̥եå */
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.tol[6]),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ǥե®٤ѹ롣
			armno		No.
			vt			ѹ°
			dat			ѹ°

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_VT		VELTYPEְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_set_vel(ARM armno, VELTYPE vt, float* dat)
{
	long	ldmy;
	int		i;
	long	axsnum;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(axsnum),&(_comuni->hu.ard.axs),1);			//	༴
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	switch(vt){
	case VT_ONEVEL:
		ldmy = (long)	EACHVelocityEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		if(axsnum==6)	dat[2]=0.0f;
		for(i=0;i<7;i++){
			st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.dev[i]),&(dat[i]),2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
		}
		break;
	case VT_XYZVEL:
		ldmy = (long)	RMRCVelocityEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.dev[7]),&(dat[0]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case VT_YPRVEL:
		ldmy = (long)	RMRCRotateEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.prm.dev[8]),&(dat[0]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_VT;
	}
	ldmy = (long)	5;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}







long	TramParRW(ARM armno,PRM* parameter,char *filename, char mode)
{
	short	fd,num=0;
	File	h;
	PRM		p;
	int		i;
	long	st;

	switch(mode){
	case 'r':
	case 'R':
		if( (fd=open(filename,O_RDONLY,0666))>0 ){
			num=read( fd, (char*)&h, sizeof(File));
			if( h.id==_CTL_PRM && num==sizeof(File) ){
				
				num=read( fd, (char *)&p, sizeof(PRM));
				for(i=0;i<AXISNUMBER;i++){
					st=pa_cpy_flt(	(long)armno,&(parameter->pul[i]),&(p.pul[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->pdl[i]),&(p.pdl[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
				}
				for(i=0;i<(AXISNUMBER+2);i++){
					st=pa_cpy_flt(	(long)armno,&(parameter->vel[i]),&(p.vel[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->dev[i]),&(p.dev[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->lim[i]),&(p.lim[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->ceh[i]),&(p.ceh[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->cem[i]),&(p.cem[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->cel[i]),&(p.cel[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
				}
				for(i=0;i<AXISNUMBER;i++){
					st=pa_cpy_flt(	(long)armno,&(parameter->pg1[i]),&(p.pg1[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->pg2[i]),&(p.pg2[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->vg1[i]),&(p.vg1[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->tg1[i]),&(p.tg1[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->pcm[i]),&(p.pcm[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->fcm[i]),&(p.fcm[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->arl[i]),&(p.arl[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->arg[i]),&(p.arg[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->arw[i]),&(p.arw[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->hom[i]),&(p.hom[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->saf[i]),&(p.saf[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->esc[i]),&(p.esc[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->tol[i]),&(p.tol[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_flt(	(long)armno,&(parameter->fvl[i]),&(p.fvl[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_lng(	(long)armno,&(parameter->dmy[i]),&(p.dmy[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
					st=pa_cpy_lng(	(long)armno,&(parameter->spa[i]),&(p.spa[i]),2);
					if(st<0){
						close(fd);
						return(st);
					}
				}
				if( num==sizeof(PRM) )break;
			}
		}
		fprintf(stderr,"Can't read \"%s\". %d\n",filename,num);
		close(fd);
		return ERR_FILE;

	case 'w':
	case 'W':
		if( (fd=open(filename,O_RDWR|O_CREAT,0666))>0 ){
			h.id=_CTL_PRM;
			strcpy(h.path,filename);
			h.comment[0]=0;
			num=write( fd, (char*)&h, sizeof(File));

			if( num==sizeof(File) ){
				num=write( fd, (char*)parameter, sizeof(PRM));
				if( num==sizeof(PRM) ){
					break;
				}
			}
		}
		fprintf(stderr,"Can't write \"%s\". %d\n",filename,num);
		close(fd);
		return ERR_FILE;
	}
	close(fd);
	return ERR_OK;
}






/**************************************************************
	楳ȥΥѥ- 
			armno		No.
			file		楳ȥѥ᡼ե

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_FILE	楳ȥѥ᡼ե뤬ץǤʤ
			ERR_INT		ߤʤä.
			ERR_PRM		ϥѥ᡼ѹϤǤʤ
****************************************************************/
DllExport long __stdcall pa_sav_ctl(ARM armno, char *file)
{
	int		i;
	PRM		p;
	long	stat;
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;

	if( ERR_OK!=(st=pa_cpy_lng((long)armno,&stat,&(_comuni->hu.get.lvl[7]),1)))	return st;	//-

	if(stat==0){

		for(i=0;i<AXISNUMBER;i++){
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.pul[i]),&(_comuni->hu.prm.pul[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.pdl[i]),&(_comuni->hu.prm.pdl[i]),1)))	return st;
		}
		for(i=0;i<(AXISNUMBER+2);i++){
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.vel[i]),&(_comuni->hu.prm.vel[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.dev[i]),&(_comuni->hu.prm.dev[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.lim[i]),&(_comuni->hu.prm.lim[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.ceh[i]),&(_comuni->hu.prm.ceh[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.cem[i]),&(_comuni->hu.prm.cem[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.cel[i]),&(_comuni->hu.prm.cel[i]),1)))	return st;
		}
		for(i=0;i<AXISNUMBER;i++){
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.pg1[i]),&(_comuni->hu.prm.pg1[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.pg2[i]),&(_comuni->hu.prm.pg2[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.vg1[i]),&(_comuni->hu.prm.vg1[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.tg1[i]),&(_comuni->hu.prm.tg1[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.pcm[i]),&(_comuni->hu.prm.pcm[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.fcm[i]),&(_comuni->hu.prm.fcm[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.arl[i]),&(_comuni->hu.prm.arl[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.arg[i]),&(_comuni->hu.prm.arg[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.arw[i]),&(_comuni->hu.prm.arw[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.hom[i]),&(_comuni->hu.prm.hom[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.saf[i]),&(_comuni->hu.prm.saf[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.esc[i]),&(_comuni->hu.prm.esc[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.tol[i]),&(_comuni->hu.prm.tol[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_flt((long)armno,&(p.fvl[i]),&(_comuni->hu.prm.fvl[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_lng((long)armno,&(p.dmy[i]),&(_comuni->hu.prm.dmy[i]),1)))	return st;
			if( ERR_OK!=(st=pa_cpy_lng((long)armno,&(p.spa[i]),&(_comuni->hu.prm.spa[i]),1)))	return st;
		}

		if(ERR_OK!=(st=TramParRW(armno,&p,file,'w')) )	return st;
	}else{
		return	ERR_PRM;
	}

	return ERR_OK;
}

/**************************************************************
	楳ȥΥѥ- -
			armno		No.
			file		楳ȥѥ᡼ե

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_FILE	楳ȥѥ᡼ե뤬ץǤʤ
			ERR_INT		ߤʤä.
			ERR_PRM		ϥѥ᡼ѹϤǤʤ
****************************************************************/
DllExport long __stdcall pa_lod_ctl(ARM armno, char *file)
{
	long	ldmy;
	long	stat;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&stat,&(_comuni->hu.get.lvl[7]),1);	//-
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if(stat==0){
		ldmy = (long)	ParamSetEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	5;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}

		if( ERR_OK!=(st=TramParRW(armno,&_comuni->hd.prm,file,'r'))){
			UnlockMutex((long)armno);
			return st;
		}
		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			UnlockMutex((long)armno);
			return st;
		}
		while(pa_fsh_chk(armno));
	}else{
		UnlockMutex((long)armno);
		return	ERR_PRM;
	}
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/**************************************************************
	ưCPUѥ᡼
			armno		No.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
****************************************************************/
DllExport long __stdcall pa_lod_def(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	SaveParamEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/**************************************************************
	ưCPUѥ᡼-
			armno		No.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
****************************************************************/
DllExport long __stdcall pa_sav_def(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	LoadParamEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

