/*


	PAlib velocity control function


*/
#include	<stdio.h>
#include	<stdlib.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

/******************************************************************
	®-ɤꤹ롣
			armno		
			vm		®٥⡼
			axis		

			ERR_OK		ｪλ
			ERR_ARM		बְäƤ.
			ERR_INT		ߤʤä.
			ERR_VM		VELMPDEְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall pa_mod_vel(ARM armno, VELMODE vm, AXIS axis)
{
	long	ldmy;
	long	axsnum;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	st=pa_cpy_lng(	(long)armno,&(axsnum),&(_comuni->hu.ard.axs),1);			//	༴
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	switch(vm){
	case VM_XYZ:
		ldmy = (long)	RMRCStartEvent3;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case VM_YPR:
		ldmy = (long)	RMRCStartEvent10;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case VM_xyz:
		ldmy = (long)	RMRCStartEvent4;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case VM_ypr:
		ldmy = (long)	RMRCStartEvent5;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case VM_ONE:
		if(axsnum==6 && axis&S3)	axis=axis-S3;							//	6λS3̵
		ldmy = (long)	EachVelocityEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case VM_XYZYPR:
		ldmy = (long)	RMRCStartEvent16;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case VM_xyzypr:
		ldmy = (long)	RMRCStartEvent17;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_VM;
	}
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	axis;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
