
set ::paPositionUpdateDelay 100

set f .paPosition
if { [winfo exist $f ] } { destroy $f }

toplevel $f

button $f.stop -text "Stop (break)" -command pa_stop -background red

button $f.close -text Close -command "paPositionStop; destroy $f"

button $f.reset -text "Stop (at curent Position)" -command paPositionStop

button $f.updates -text "Updates sliders" -command paPositionUpdate

button $f.goto -text "Start position control" -command paPositionGoto

foreach el { s1 s2 e1 e2 w1 w2 } {
    frame $f.$el
    label $f.$el.l -text $el
    scale $f.$el.s -length 200 -variable ::paPositionQ[set el] \
	-orient horizontal -resolution 0.01 -tickinterval 0 \
	-command "::paQ7Position configure -$el"
    eval pack [winfo children $f.$el] -side left
}

$f.s1.s configure -from [degRad -177] -to [degRad 177]
$f.s2.s configure -from [degRad -64 ] -to [degRad 124]
$f.e1.s configure -from [degRad -107] -to [degRad 158]
$f.e2.s configure -from [degRad -255] -to [degRad 255]
$f.w1.s configure -from [degRad -165] -to [degRad 165]
$f.w2.s configure -from [degRad -255] -to [degRad 255]

foreach el { s1 s2 e1 e2 w1 w2 } {
    $f.$el.s configure -tickinterval \
	[expr [$f.$el.s cget -to] - [$f.$el.s cget -from] - 0.009]
}




eval pack [winfo children $f]

set paQ7Position [ANGLE paQ7Position]

proc paPositionStop { } {
    # may be it's not the good solution
    proc paUpdatePosition { } { }
    set status [pa_sus_arm $::armNo $::WM_NOWAIT]
    paErrorStatus pa_sus_arm $status
}

proc paPositionUpdate { } {
    set status [pa_get_agl $::armNo $::paQ7Position]
    paErrorStatus pa_get_agl $status 
    foreach el { s1 s2 e1 e2 w1 w2 } {
	set ::paPositionQ[set el] [ANGLE_[set el]_get $::paQ7Position]
    }
}

proc paPositionGoto { } {
    paPositionUpdate
    # pa_set_tim : 20 is 200 ms
    set status [pa_set_tim $::armNo 20]
    paErrorStatus pa_set_tim $status
    set status [pa_odr_axs $::armNo $::paQ7Position]
    paErrorStatus pa_odr_axs $status
    set status [pa_mod_axs $::armNo]
    paErrorStatus pa_mod_axs $status
    define_paUpdatePosition
    paUpdatePosition
}

proc define_paUpdatePosition { } {
    proc paUpdatePosition { } {
	puts "paUpdatePosition"
	set status [pa_odr_axs $::armNo $::paQ7Position]
	paErrorStatus pa_odr_axs $status
	after $::paPositionUpdateDelay paUpdatePosition
    }
}
