/*

	PAlib support function (pa_ext.c)

*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

#ifndef M_PI
#define M_PI        3.14159265358979323846
#endif
#define	RadToDeg(x) ((x)*180.0/M_PI)

/*********************************************************************
	Ҽ-ߡۥ쵥
		armno		No.

		ť	ERR_OK		ۥ
			ERR_ARM   	No.㥨衼榥ơˡ
			ERR_INT		ߤʤä
			ʾ¾फΥ顼ޤ
**********************************************************************/
DllExport long  pa_sta_sim(ARM armno)
{
	long	st;
	static	long	ldmy;

	LockMutex((long)armno);										//S2-W2ֵΥ
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	4;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SimOnEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}						
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/*********************************************************************
	ߥ-潪λ
			armno		No.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
*********************************************************************/
DllExport long  pa_ext_sim(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);										//S2-W2ֵΥ
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	4;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SimOffEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}					
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/*********************************************************************
	ڤӥ-ӥ󥰵ƻԤ.

		armno		No.
		trans		䥦-ӥ󥰵ƻID
				(MODE_WAVEH|MODE_WAVER|MODE_SENSH|MODE_SENSR)
				(ƻ)-

		ERR_OK		ｪλ
		ERR_ARM		No.ְäƤ.
		ERR_INT		ߤʤä.
		ʾ¾फΥ顼ޤ
**********************************************************************/
DllExport long  pa_odr_xyz(ARM armno,TRANSMATP trans)
{
	int	i;
	long	ldmy;
	long	st;

	LockMutex((long)armno);										//S2-W2ֵΥ
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	8;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.trn.Enable),&(trans->Enable),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	for(i=0;i<3;i++){
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.trn._xyz[i]),	&(trans->_xyz[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.trn.Ixyz[i]),	&(trans->Ixyz[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.trn._XYZ[i]),	&(trans->_XYZ[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.trn.IXYZ[i]),	&(trans->IXYZ[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.trn._wave[i]),&(trans->_wave[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.trn.Iwave[i]),&(trans->Iwave[i]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}
	ldmy = (long)	SendOffsetEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_sub(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_sub(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	Σģϥǡݥ̵ͭꤷޤ.

		armno		No.
		sw			̵ͭѥݥ

		ERR_OK		ｪλ
		ERR_ARM		No.ְäƤ.
		ERR_INT		ߤʤä.
		ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_swt_dio(ARM armno,long sw)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	8;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if(sw){	
		ldmy = (long)	DioOnEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}else{
		ldmy = (long)	DioOffEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}

	if( ERR_OK!=(st=pa_req_sub(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_sub(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ʣУԣСˤΣģϥǡݥ°ꤷޤ.

		armno		No.
		dp			DO-°

		ERR_OK		ｪλ
		ERR_ARM		No.ְäƤ.
		ERR_INT		ߤʤä.
		ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_chg_dio(ARM armno, DIOSTATUSP dp)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = ((long)dp->io1|(long)dp->io2<<8)|((long)dp->io3<<16)|((long)dp->io4<<24);
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SetDIOEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	°ꤹ롣
			armno		No.
			pa			ѹ°
			dat			ѹ°

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_PA		PntSetIDְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_idn(ARM armno, PNTID pa, long dat)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	switch(pa){
	case PA_SETID:
		ldmy = (long)	SetIDEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_PA;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&dat,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ɸѴ
			armno		No.
			mtx0		
			mtx1		

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_mat(ARM armno, MATRIX mtx0, MATRIX mtx1)
{
	short	j,k;
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	SendMatrixEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	6;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	for(j=0;j<3;j++){
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.wrk[0].xyz[j]),&(mtx0[j][3]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.wrk[1].xyz[j]),&(mtx1[j][3]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		for(k=0;k<3;k++){
			st=pa_cpy_flt((long)armno,&(_comuni->hd.wrk[0].noa[j][k]),&(mtx0[j][k]),2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt((long)armno,&(_comuni->hd.wrk[1].noa[j][k]),&(mtx1[j][k]),2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
		}
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	RMRC ӣгٻˤĹư
			armno		No.
			s3			ӣ
			wfp			ưλޤԤĤɤλ

			ERR_OK		ｪλ
			ERR_ARM   	No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_mov_jou(ARM armno, float s3, long wfp)
{
	long	ldmy;
	long	axsnum;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(axsnum),&(_comuni->hu.ard.axs),1);			//	༴
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if(axsnum==6){
		UnlockMutex((long)armno);
		return ERR_OK;
	}

	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0x04;							
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.agl[2]),&s3,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	RMRCStartEvent14;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	pam_exe_wfp(armno,wfp);
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	Ƽ͸Ǥݥ
			armno		No.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_mod_axs(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0x7f;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	EachAngleEvent2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	Ƽ͸Ǥ⡼
			armno		No.
			an		ANGLEؤΥݥ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_odr_axs(ARM armno, ANGLEP an)
{
	long	ldmy;
	long	axsnum;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(axsnum),&(_comuni->hu.ard.axs),1);			//	༴
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	SendANGLEEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	7;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[0]),&(an->s1),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[1]),&(an->s2),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if(axsnum==6)	an->s3=0.0f;
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[2]),&(an->s3),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[3]),&(an->e1),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[4]),&(an->e2),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[5]),&(an->w1),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.mat.agl[6]),&(an->w2),2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}

	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	쥯桤(Ƽ®)Ʊ
			armno		No.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_chk_cnt(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	ResetTimeOutEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ƱΥॢȻ֤
			armno		No.
			tim		ƱΥॢȻ[*10msec]

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_tim(ARM armno, long tim)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&tim,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SetTimeOutEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	եå­ߤΥߥåк
			armno		No.
			data		եå­ߤΥߥåк[mm]

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_lmt_xyz(ARM armno, float data)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	5;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SetOffsetVelEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&data,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ץ쥤ХåDOܥåȤưƱƼưŪߤ뤫ݤ
			armno		-No.
			data		0 : ưߤͭ
					1 :           ̵

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_dlc(ARM armno, long data)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&data,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SetDIOLockEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ߥ졼Ψ
			armno		-No.
			tim			ߥ졼Ψ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_sim(ARM armno, long tim)
{
	long	ldmy;
	float	fdmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SetSimTimeEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	fdmy=(float)tim;
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&fdmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ꥢ륿®
			armno		-No.
			inc			ꥢ륿®

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_inc(ARM armno, float inc)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	SetDefIncEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&inc,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_sub(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_sub(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ߥ졼Ψ
			armno		-No.
			*sim		ߥ졼Ψ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_get_sim(ARM armno, long* sim)
{
	float	fdmy;
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_flt((long)armno,&fdmy,&(_comuni->hu.get.fvl[1]),1)))	return st;
	*sim=(long)fdmy;

	return pam_get_err(armno);
}
/******************************************************************
	ꥢ륿®ټ
			armno		-No.
			*inc		ꥢ륿®

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_get_inc(ARM armno, float* inc)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_flt((long)armno,inc,&(_comuni->hu.get.fvl[3]),1)))	return st;
	return pam_get_err(armno);
}
/******************************************************************
	ܥåȥǥե
			armno		-No.
			*file		ܥåȥǥե̾

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_lod_rob(ARM armno,char *file)
{
	int		fd;
	long	i,j,flag=1,ldmy;
	long	all,cnt=0,blk=0,num=0;
	char*	cdat;
	BSE		p;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	cdat=(char*)malloc(sizeof(char)*10000+1);
	if(cdat==NULL){
		UnlockMutex((long)armno);
		return ERR_MALLOC;
	}

	fd=open(file,O_RDONLY,0666);
	num=read(fd,cdat,10000);
	cdat[num+1]=(char)'\0';
	close(fd);
	all=num/256+1;

	while(flag){
		ldmy=(long)5;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)EV_LOD_ROB;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)MOD_ROBFILE;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)all;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)++cnt;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[2]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		if(num>256) blk=256;
		else blk=num;
		ldmy=(long)blk;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[3]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		num-=256;

		for(i=(cnt-1)*256,j=0; i<(cnt*256) && cdat[i]!='\0'; i++,j++){
			p.pkt[j]=cdat[i];
		}
		st=pa_mem_blk((long)armno,&(_comuni->hd.bse.pkt[0]),&(p.pkt[0]),(size_t)j,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}

		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		while( pa_fsh_chk(armno) );
		if(all==cnt) break;
	}

	free(cdat);
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ġǥե
			armno		-No.
			*file		ġǥե̾

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_lod_tol(ARM armno,char *file)
{
	int		fd;
	long	i,j,flag=1,ldmy;
	long	all,cnt=0,blk=0,num=0;
	char*	cdat;
	BSE		p;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	cdat=(char*)malloc(sizeof(char)*10000+1);
	if(cdat==NULL){
		UnlockMutex((long)armno);
		return ERR_MALLOC;
	}

	fd=open(file,O_RDONLY,0666);
	num=read(fd,cdat,10000);
	cdat[num+1]=(char)'\0';
	close(fd);
	all=num/256+1;

	while(flag){
		ldmy=(long)5;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)EV_LOD_ROB;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)MOD_TOLFILE;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)all;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		ldmy=(long)++cnt;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[2]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		if(num>256) blk=256;
		else blk=num;
		ldmy=(long)blk;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[3]),&ldmy,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		num-=256;

		for(i=(cnt-1)*256,j=0; i<(cnt*256) && cdat[i]!='\0'; i++,j++){
			p.pkt[j]=cdat[i];
		}
		st=pa_mem_blk((long)armno,&(_comuni->hd.bse.pkt[0]),&(p.pkt[0]),(size_t)i,2);
		if(st<0){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}

		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			free(cdat);
			UnlockMutex((long)armno);
			return st;
		}
		while( pa_fsh_chk(armno) );
		if(all==cnt) break;
	}

	free(cdat);
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ܥåȥǥե륻
			armno		-No.
			*file		ܥåȥǥե̾

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_sav_rob(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy=(long)5;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy=(long)EV_SAV_ROB;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );

	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	RETRAC黻
			armno		-No.
			sw		0:T黻
					1:RETRAC黻

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_ena_nom(ARM armno,long sw)
{
	long	ldmy;
	long	st;


	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy=(long)0;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy=(long)EV_ENA_NOM;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy=(long)sw;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );

	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	T黻RETRAC黻ΤɤԤäƤ뤫
			armno		No.
			nom		0:T黻  
						1:RETRAC黻

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_get_nom(ARM armno, long* nom)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,nom,&(_comuni->hu.get.lvl[5]),1)))	return st;
	return pam_get_err(armno);
}

/**************************************************************************
	ƼON/OFFּ
			armno		No.
			sav		ƥ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
*************************************************************************/
DllExport long  pa_get_sav(ARM armno, long* sav)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,sav,&(_comuni->hu.rio.odt.sav),1)))	return st;
	return pam_get_err(armno);
}

/**************************************************************************
	Ƽܥƥ
			armno		No.
			sts		ƥ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
*************************************************************************/
DllExport long  pa_sav_sts(ARM armno, long* sts)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;

	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[0]),&(_comuni->hu.err.drv[0]),1)))	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[1]),&(_comuni->hu.err.drv[1]),1)))	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[2]),&(_comuni->hu.err.drv[2]),1)))	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[3]),&(_comuni->hu.err.drv[3]),1)))	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[4]),&(_comuni->hu.err.drv[4]),1)))	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[5]),&(_comuni->hu.err.drv[5]),1)))	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[6]),&(_comuni->hu.err.drv[6]),1)))	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&(sts[7]),&(_comuni->hu.err.drv[7]),1)))	return st;

	return pam_get_err(armno);
}

/**************************************************************************
	RETRACѥ᡼⡼ON/OFF
			armno		No.
			sw			0:OFF
							1:ON

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
*************************************************************************/
DllExport long  pa_tst_nom(ARM armno, long sw)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_TST_NOM;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	sw;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}


	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/**************************************************************************
	RETRACѥ᡼⡼ON/OFF
			armno		No.
			*sw		0:OFF
					1:ON

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
*************************************************************************/
DllExport long  pa_get_rmd(ARM armno, long* sw)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,sw,&(_comuni->hu.get.lvl[9]),1)))		return st;
	return pam_get_err(armno);
}

/******************************************************************
	RETRAC黻ǽɤ
			armno		No.
			nom		0:Բǽ 
						1:ǽ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_tkn_nom(ARM armno, long* nom)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,nom,&(_comuni->hu.get.lvl[6]),1)))	return st;
	return pam_get_err(armno);
}

/******************************************************************
			armno		No.
			snd			 
			rcv						

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_PRM		ϥѥ᡼ѹϤǤʤ
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_ini_drv(ARM armno, char* snd, char* rcv)
{
	long	ldmy;
	long	stat;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	st=pa_cpy_lng(	(long)armno,&stat,&(_comuni->hu.get.lvl[7]),1);	//-
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if(stat==0){
		ldmy = (long)	InitDSPEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	4;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_mem_blk( (long)armno,&(_comuni->hd.bse.pkt[0]),snd,256,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}

		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			UnlockMutex((long)armno);
			return st;
		}

		while( pa_fsh_chk(armno) );
		UnlockMutex((long)armno);

		if( ERR_OK==(st=pam_get_err(armno)) ){
			pa_map_ctl(armno);

			if(ERR_OK!=(st=pa_mem_blk( (long)armno,rcv,&(_comuni->hu.bse.pkt[0]),256,1)))	return st;
		}
	}else{
		UnlockMutex((long)armno);
		return	ERR_PRM;
	}

	return pam_get_err(armno);
}

/******************************************************************
	ǥåɥޥ󥹥åͭ/̵
			armno		No.
			type		åμ	 
			val		1:ͭ	
					0:̵

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_set_ddm(ARM armno, long type, long val)
{
	long	ldmy;
	long	bit;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_lng(	(long)armno,&bit,&(_comuni->hu.get.lvl[10]),1);	//åξ
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_SET_DDM;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	5;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if(val==1){
		bit|=(1<<type);
	}else{
		bit&=~(1<<type);
	}
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&bit,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ǥåɥޥ󥹥åͭ/̵ּ
			armno		No.
			type		åμ	 
			val		1:ͭ	
					0:̵

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_get_ddm(ARM armno, long type, long* val)
{
	long	bit;
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,&bit,&(_comuni->hu.get.lvl[10]),1)))	return st;	//åξ
	*val=((unsigned char)bit>>type);

	return pam_get_err(armno);
}
