/*


	PAlib convert matrix function


*/
#include	<stdio.h>
#include	<stdlib.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

/******************************************************************
	ɸѴ
			armno		No.
			mtx0		

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_mtx(ARM armno, MATRIX mtx0)
{
	short	j,k;
	long	ldmy;
	long	st;
	MATRIX	Imtx = {{ (float)1.0, (float)0.0, (float)0.0, (float)0.0 },
			{ (float)0.0, (float)1.0, (float)0.0, (float)0.0 },
			{ (float)0.0, (float)0.0, (float)1.0, (float)0.0 }};

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	SendMatrixEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	6;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	for(j=0;j<3;j++){
		st=pa_cpy_flt((long)armno,&(_comuni->hd.wrk[0].xyz[j]),&(mtx0[j][3]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt((long)armno,&(_comuni->hd.wrk[1].xyz[j]),&(Imtx[j][3]),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		for(k=0;k<3;k++){
			st=pa_cpy_flt((long)armno,&(_comuni->hd.wrk[0].noa[j][k]),&(mtx0[j][k]),2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt((long)armno,&(_comuni->hd.wrk[1].noa[j][k]),&(Imtx[j][k]),2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
		}
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
