#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<string.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

#ifndef M_PI
#define M_PI        3.1415926535897932384626433832795
#endif
#define	RadToDeg(x) (float)((x)*180.0/M_PI)
#define	DegToRad(x) (float)((x)*M_PI/180.0)

/******************************************************************
	ʸ򥳥޶ڤǼ
	strtokǤϢ³ޤδ֤Ǥʤä
******************************************************************/
char *strtokex(char *szSrc, const char cDelimit)
{
	static char		*szStart;
	char			*szRet;
	int				i;

	if(szSrc)		szStart=szSrc;

	for(i=0; ; i++){
	 	if(cDelimit==szStart[i] || szStart[i]==0x0a || szStart[i]==0x0d){
			szStart[i]=(char)NULL;

			szRet=szStart;
			szStart+=(i+1);

			return(szRet);
		}else if(!szStart[i]){
			if(0==i)	return(NULL);

			szRet=szStart;
			szStart+=i;

			return(szRet);
		}
	}
	return(NULL);
}

/******************************************************************
	ߤζư롣
			armno		No.
			pm			ư趵λ
			no			jumpλΰưNo.

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_PM		PNTMOVEְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_chg_pnt(ARM armno, PNTMOVE pm, long no)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	switch(pm){
	case PM_TOP:
		ldmy = (long)	TopPointerEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PM_NEXT:
		ldmy = (long)	SForeStepEvent;;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PM_PRIV:
		ldmy = (long)	SBackStepEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PM_BTM:
		ldmy = (long)	EndPointerEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PM_JMP:
		ldmy = (long)	JumpPointerEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&no,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PM_CIR:
		ldmy = (long)	CircleSerchEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PM_ARC:
		ldmy = (long)	ArcSerchEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_PM;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ߤζư롣
			armno	No.
			key		ǡKeyֹ
			cmt		Ȼ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_jmp_cmt(ARM armno, long key, char* cmt)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_JMP_CMT;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	key;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	cmt[32]='\0';
	if(strlen(cmt)<32){
		st=pa_mem_blk(	(long)armno,&(_comuni->hd.ply.cmt[0])	,cmt,(size_t)(strlen(cmt)+1),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}
	else{
		st=pa_mem_blk(	(long)armno,&(_comuni->hd.ply.cmt[0])	,cmt,(size_t)32,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);

}
/******************************************************************
	ͤ򶵼ɲä롣
			armno			No.
			pt			ɲð֤ȥ-

			ERR_OK			ｪλ
			ERR_ARM			No.ְäƤ.
			ERR_INT			ߤʤä.
			ERR_PT			PNTTYPEְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_add_pnt(ARM armno, PNTTYPE pt)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	switch(pt){
	case PT_CP:
		ldmy = (long)	ReadCPEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_PTP:
		ldmy = (long)	ReadPTPEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_BCP:
		ldmy = (long)	ReadCPEvent2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_BPTP:
		ldmy = (long)	ReadPTPEvent2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_ARC1:
		ldmy = (long)	ReadArc1Event;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_ARC2:
		ldmy = (long)	ReadArc2Event;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_ARC3:
		ldmy = (long)	ReadArc3Event;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_CIR1:
		ldmy = (long)	ReadCircle1Event;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_CIR2:
		ldmy = (long)	ReadCircle2Event;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_CIR3:
		ldmy = (long)	ReadCircle3Event;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_AXS:
		ldmy = (long)	ReadPTPEvent3;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_BAXS:
		ldmy = (long)	ReadPTPEvent4;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_POS:
		ldmy = (long)	ReadPTPEvent5;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_BPOS:
		ldmy = (long)	ReadPTPEvent6;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_ARC4:
		ldmy = (long)	ReadArc1Event2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_ARC5:
		ldmy = (long)	ReadArc2Event2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_ARC6:
		ldmy = (long)	ReadArc3Event2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_CIR4:
		ldmy = (long)	ReadCircle1Event2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_CIR5:
		ldmy = (long)	ReadCircle2Event2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;
	case PT_CIR6:
		ldmy = (long)	ReadCircle3Event2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		break;

	default:
		UnlockMutex((long)armno);
		return ERR_PT;
	}
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	롣
			armno		No.
			pd		붵

			ERR_OK		ｪλ
			ERR_ARM		ARMְäƤ.
			ERR_INT		ߤʤä.
			ERR_PD		PNTDELְ㤤
			ERR_PRJ		ץȤ¸ߤʤ
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_del_pnt(ARM armno, PNTDEL pd)
{
	extern	long	pa_act_pnt_sub(ARM,long);
	extern	long	pa_ply_set_sub(ARM,long,long*);
	long	ldmy;
	long	key;	
	long	num,i;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	switch(pd){
	case PD_CUR:
		ldmy = (long)	DeleteCPointerEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}

		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			UnlockMutex((long)armno);
			return st;
		}
		while( pa_fsh_chk(armno) );
		UnlockMutex((long)armno);
		break;
	case PD_FORE:
		ldmy = (long)	DeletePointerEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}

		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			UnlockMutex((long)armno);
			return st;
		}
		while( pa_fsh_chk(armno) );
		UnlockMutex((long)armno);
		break;
	case PD_ALL:
		ldmy = (long)	DeleteAllPointerEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	0;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}

		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			UnlockMutex((long)armno);
			return st;
		}
		while( pa_fsh_chk(armno) );
		UnlockMutex((long)armno);
		break;
	case PD_ALLDATA:
		st=pa_cpy_lng(	(long)armno,&(num),	&(_comuni->hu.sts.lvl[2]),1);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		if(num==0){
			UnlockMutex((long)armno);
			return ERR_PRJ;
		}
		for(i=0;i<num;i++){
			if(ERR_OK!=(st=pa_ply_set_sub(armno,0,&key))){
				UnlockMutex((long)armno);
				return st;
			}
			if(ERR_OK!=(st=pa_act_pnt_sub(armno,key))){
				UnlockMutex((long)armno);
				return st;
			}

			if( ERR_OK!=(st=pa_map_ctl(armno)) ){
				UnlockMutex((long)armno);
				return st;
			}
			ldmy = (long)	DeleteAllPointerEvent;
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			ldmy = (long)	0;
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			ldmy = (long)	1;
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}

			if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
				UnlockMutex((long)armno);
				return st;
			}
			while( pa_fsh_chk(armno) );
		}
		UnlockMutex((long)armno);
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_PD;
	}
	return pam_get_err(armno);
}

/******************************************************************
	°ꤹ롣
			armno		No.
			pa		ѹ°
			ldat		ѹ°
			fdat		paˤꤹ°ͤ㤦

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_PA		PntSetIDְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_pnt(ARM armno, PNTATTR pa, long* ldat, float fdat)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	switch(pa){
	case PA_CHGVEL:
		ldmy = (long)	ChVelocityEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&fdat,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PA_CHGWAIT:
		ldmy = (long)	ChWaitTimeEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldat[0],2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PA_VELPTN:
		ldmy = (long)	ChVptnEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		if(0<=ldat[0]||ldat[0]<=4){
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldat[0],2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldat[1],2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldat[2],2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			break;
		}
		UnlockMutex((long)armno);
		return ERR_PTN;
	case PA_ROTVEL:
		ldmy = (long)	ChRotateEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&fdat,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PA_AXSACC:
		ldmy = (long)	EV_AXS_ACC;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&fdat,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PA_RMRCACC:
		ldmy = (long)	EV_RMC_ACC;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&fdat,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PA_JUMPID:
		ldmy = (long)	EV_PNT_JMP;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldat[0],2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_PA;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ͤǥȥݥ֤ͤ롣
			armno		

			ERR_OK		ｪλ
			ERR_ARM		ְ꤬äƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_rpl_pnt(ARM armno)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	ReadReplaceEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ߤζư롣(ץ쥤Хåư)
			armno		No.
			wfp		ưδλޤԤĤɤλ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_mov_pnt(ARM armno, long wfp)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	PlayBackReadyEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	2;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0x7f;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	pam_exe_wfp(armno,wfp);
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	˶ư롣(ץ쥤Хåư)
			armno		No.
			pb		ư
			number		Ϣ³ץ쥤Хåβ
						-1̵¡
			wfp		ưδλޤԤĤɤλ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_PB		PLAYBACKְ㤤
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_ply_pnt(ARM armno, PLAYBACK pb, long number, long wfp)
{
	long	st;
	long	ldmy;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	switch(pb){
	case PB_FORES:
		ldmy = (long)	ForeStepEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PB_BACKS:
		ldmy = (long)	BackStepEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	2;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	case PB_FORE:
		ldmy = (long)	PBTOPStartEvent;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	number;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_PB;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	pam_exe_wfp(armno,wfp);
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ե뤫-ɤ롣
			armno	-No.
			key	keyֹ
			file	-ե

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_FILE	ե뤬ץǤʤ
			ERR_INT		ߤʤä.
******************************************************************/
DllExport long  pa_lod_pnt(ARM armno, long key, char *file)
{
	extern	unsigned long atox(char*);
	short	i=0;
	PNTDAT	pntdat;
	long	err;
	static	long	ldmy;
	long	cnt=1;
	char	buff[512];
	FILE*	stream;
	long	num;
	long	aldmy,rldmy;
	char	cmt[33];
	char	*szTok;
	char	cDelimit=',';
	long	st;
	PARAM	prm;
	long	j;

	num=0;

	st=pa_get_prm(armno,&prm);
	if( (stream  = fopen( file, "r" )) != NULL ){
		while(fgets(buff, sizeof(buff), stream)){
			szTok=strtokex(buff, cDelimit);
			if(strcmp(szTok,"JUMP")==0 || strcmp(szTok,"JUMP\n")==0){
				break;
			}
			num++;
		}
		fclose(stream);
	}
	else		return ERR_FILE;

	if(num!=1){
		LockMutex((long)armno);
		if( ERR_OK!=(err=pa_map_ctl(armno)) ){
			UnlockMutex((long)armno);
			return err;
		}
		ldmy = (long)	'S';
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	key;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	1;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[2]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	DataLoad;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
		ldmy = (long)	3;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
//		UnlockMutex((long)armno);
	}

	if( (stream  = fopen( file, "r" )) != NULL ){
		while(fgets(buff, sizeof(buff), stream)){
			pntdat.ply.pnt.atr[4]	=(szTok=strtokex(buff, cDelimit))?atol(szTok):0;			/*ֹ̤ */
			pntdat.ply.pnt.atr[5]	=(szTok=strtokex(NULL, cDelimit))?atol(szTok):0;			/*ID */
			memset(pntdat.ply.cmt,0,sizeof(pntdat.ply.cmt));
			if((szTok=strtokex(NULL, cDelimit))){
				int		iLen=strlen(szTok);
				int		iSize=sizeof(pntdat.ply.cmt);
				int		iCopySize=(iLen<=iSize)?iLen:iSize;
				memcpy(pntdat.ply.cmt, szTok, iCopySize);									/* */
			}

			pntdat.ply.pnt.agl[0]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*S1 */
			pntdat.ply.pnt.agl[1]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*S2 */
			pntdat.ply.pnt.agl[2]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*S3 */
			pntdat.ply.pnt.agl[3]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*E1 */
			pntdat.ply.pnt.agl[4]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*E2 */
			pntdat.ply.pnt.agl[5]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*W1 */
			pntdat.ply.pnt.agl[6]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*W2 */
			pntdat.ply.pnt.vel[0]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*®[mm/sec] */
			pntdat.ply.pnt.vel[1]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/*®[deg/sec] */

			szTok=strtokex(NULL, cDelimit);
			if(szTok!=NULL){
				if(strcmp(szTok,"PTP")==0)	pntdat.ply.pnt.atr[0]	=1;					/* PTP/PTP(NOAP) */
				else if(strcmp(szTok,"NOAP")==0)pntdat.ply.pnt.atr[0]	=2;
			}else{
				fclose(stream);
				return ERR_FILE;
			}
			szTok=strtokex(NULL, cDelimit);
			if(szTok!=NULL){
				if(strcmp(szTok,"EACH")==0)		pntdat.ply.pnt.atr[1]	=21;				/*ˡ ľ//߸ */
				else if(strcmp(szTok,"LINE")==0)	pntdat.ply.pnt.atr[1]	=18;
				else if(strcmp(szTok,"ARC")==0)		pntdat.ply.pnt.atr[1]	=17;
				else if(strcmp(szTok,"CIRCLE")==0)	pntdat.ply.pnt.atr[1]	=16;
			}else{
				fclose(stream);
				return ERR_FILE;
			}
			aldmy	=(long)(((szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f)*10)&0x0000ffff;			/*١ʳƼ */
			rldmy	=((long)(((szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f)*10)&0x0000ffff)<<16;	/*١RMRC */
			pntdat.ply.pnt.atr[7]	=aldmy|rldmy;
			szTok=strtokex(NULL, cDelimit);
			if(szTok!=NULL){
				if(strcmp(szTok,"Line")==0)	pntdat.ply.pnt.atr[2]	=0;/*®٥ */
				else if(strcmp(szTok,"StartUp")==0)	pntdat.ply.pnt.atr[2]	=1;
				else if(strcmp(szTok,"ShutDown")==0)	pntdat.ply.pnt.atr[2]	=2;
				else if(strcmp(szTok,"Trap")==0)	pntdat.ply.pnt.atr[2]	=3;
			}else{
				fclose(stream);
				return ERR_FILE;
			}
			pntdat.ply.pnt.atr[9]	=(szTok=strtokex(NULL, cDelimit))?atol(szTok):0;				/*®[*0.01msec] */
			pntdat.ply.pnt.atr[10]	=(szTok=strtokex(NULL, cDelimit))?atol(szTok):0;				/*®[*0.01msec] */
			pntdat.ply.pnt.atr[8]	=(szTok=strtokex(NULL, cDelimit))?atol(szTok):0;				/*JUMPֹ */
			pntdat.ply.pnt.atr[6]	=(szTok=strtokex(NULL, cDelimit))?atox(szTok):0;				/*DO16ʿ */
			pntdat.ply.pnt.atr[3]	=(szTok=strtokex(NULL, cDelimit))?atol(szTok):0;				/*Ԥ[msec] */
			if(pntdat.ply.pnt.atr[0]==2){
				pntdat.noa.xyz[0]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.xyz[1]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.xyz[2]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[0][0]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[0][1]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[0][2]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[1][0]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[1][1]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[1][2]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[2][0]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[2][1]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
				pntdat.noa.noa[2][2]	=(szTok=strtokex(NULL, cDelimit))?(float)atof(szTok):0.0f;	/* */
			}
			pntdat.ply.pnt.agl[0]=DegToRad(pntdat.ply.pnt.agl[0]);	/*S1*/
			pntdat.ply.pnt.agl[1]=DegToRad(pntdat.ply.pnt.agl[1]);	/*S2*/
			pntdat.ply.pnt.agl[2]=DegToRad(pntdat.ply.pnt.agl[2]);	/*S3*/
			pntdat.ply.pnt.agl[3]=DegToRad(pntdat.ply.pnt.agl[3]);	/*E1*/
			pntdat.ply.pnt.agl[4]=DegToRad(pntdat.ply.pnt.agl[4]);	/*E2*/
			pntdat.ply.pnt.agl[5]=DegToRad(pntdat.ply.pnt.agl[5]);	/*W1*/
			pntdat.ply.pnt.agl[6]=DegToRad(pntdat.ply.pnt.agl[6]);	/*W2*/
			for(j=0;j<6;j++){
				if(pntdat.ply.pnt.agl[j]>prm.pul[j]-0.001f || pntdat.ply.pnt.agl[j]<prm.pdl[j]+0.001f)	return ERR_PNT;
			}
			pntdat.ply.pnt.vel[1]=DegToRad(pntdat.ply.pnt.vel[1]);	/*®[deg/sec]*/

			pa_map_ctl(armno);

			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.agl[0]),&(pntdat.ply.pnt.agl[0]),2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.agl[1]),&(pntdat.ply.pnt.agl[1]),2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.agl[2]),&(pntdat.ply.pnt.agl[2]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.agl[3]),&(pntdat.ply.pnt.agl[3]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.agl[4]),&(pntdat.ply.pnt.agl[4]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.agl[5]),&(pntdat.ply.pnt.agl[5]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.agl[6]),&(pntdat.ply.pnt.agl[6]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.vel[0]),&(pntdat.ply.pnt.vel[0]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(armno,&(_comuni->hd.ply.pnt.vel[1]),&(pntdat.ply.pnt.vel[1]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[0]),&(pntdat.ply.pnt.atr[0]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[1]),&(pntdat.ply.pnt.atr[1]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[2]),&(pntdat.ply.pnt.atr[2]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[3]),&(pntdat.ply.pnt.atr[3]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[4]),&(pntdat.ply.pnt.atr[4]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[5]),&(pntdat.ply.pnt.atr[5]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[6]),&(pntdat.ply.pnt.atr[6]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[7]),&(pntdat.ply.pnt.atr[7]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[8]),&(pntdat.ply.pnt.atr[8]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[9]),&(pntdat.ply.pnt.atr[9]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[10]),&(pntdat.ply.pnt.atr[10]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(armno,&(_comuni->hd.ply.pnt.atr[11]),&(pntdat.ply.pnt.atr[11]),2	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}

			if(strlen(pntdat.ply.cmt)<32){
				st=pa_mem_blk(	(long)armno,&(_comuni->hd.ply.cmt[0])	,&(pntdat.ply.cmt[0]),(size_t)(strlen(pntdat.ply.cmt)+1),2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
			}
			else{
				memcpy(cmt,pntdat.ply.cmt,33);
				st=pa_mem_blk(	(long)armno,&(_comuni->hd.ply.cmt[0])	,cmt,(size_t)32	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
			}
			if(pntdat.ply.pnt.atr[0]==2){
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.xyz[0]),	&(pntdat.noa.xyz[0])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.xyz[1]),	&(pntdat.noa.xyz[1])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.xyz[2]),	&(pntdat.noa.xyz[2])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[0][0]),&(pntdat.noa.noa[0][0])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[0][1]),&(pntdat.noa.noa[0][1])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[0][2]),&(pntdat.noa.noa[0][2])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[1][0]),&(pntdat.noa.noa[1][0])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[1][1]),&(pntdat.noa.noa[1][1])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[1][2]),&(pntdat.noa.noa[1][2])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[2][0]),&(pntdat.noa.noa[2][0])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[2][1]),&(pntdat.noa.noa[2][1])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	armno,&(_comuni->hd.noa.noa[2][2]),&(pntdat.noa.noa[2][2])	,2	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
			}

			i++;
			if(num==i){
				ldmy = (long)	'E';
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	key;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	1;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[2]),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	DataLoad;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	3;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}

				if( ERR_OK!=(err=pa_req_ctl(armno,RETRY_COUNT)) ){
					UnlockMutex((long)armno);
					return err;
				}

				while( pa_fsh_chk(armno) );
				UnlockMutex((long)armno);
				if( pam_get_err(armno) )break;
				break;
			}
			if(num!=i && num>2 && i!=1){
//				LockMutex((long)armno);
				pa_map_ctl(armno);
				ldmy = (long)	'C';
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	key;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[1]),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	1;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[2]),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	DataLoad;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				ldmy = (long)	3;
				st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
//				UnlockMutex((long)armno);
			}

			if( ERR_OK!=(err=pa_req_ctl(armno,RETRY_COUNT)) ){
				UnlockMutex((long)armno);
				return err;
			}
//			UnlockMutex((long)armno);
			while( pa_fsh_chk(armno) );
			if( pam_get_err(armno) )break;

		}
		fclose(stream);
	}
	else		return ERR_FILE;
	
	return pam_get_err(armno);
}

/******************************************************************
	ե˥-֤롣
			armno	-No.
			file	-ե

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_OPEN	pa_opn_arm()¹ԤƤʤ.
			ERR_FILE	ե뤬ץǤʤ
			ERR_INT		ߤʤä.
******************************************************************/
DllExport long  pa_sav_pnt(ARM armno, char *file)
{
	long	err=0;
	static	long	datatype,Tnum;
	short	flg=1;
	PNTDAT	pntdat;
	long	ldmy;
	FILE*	stream;
	float	afdmy;
	float	rfdmy;
	char	cmt[33];
	long	st;


	if( (stream  = fopen( file, "w" )) != NULL ){
		datatype = 1;
		Tnum = 0;
		LockMutex((long)armno);
		while(flg){
//			LockMutex((long)armno);
			if( ERR_OK!=(err=pa_map_ctl(armno)) ){
				UnlockMutex((long)armno);
				return err;
			}

			ldmy = (long)	DataSave;
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			ldmy = (long)	3;
			st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}

			if( ERR_OK!=(err=pa_req_ctl(armno,RETRY_COUNT)) ){
				UnlockMutex((long)armno);
				return err;
			}
//			UnlockMutex((long)armno);

			while( pa_fsh_chk(armno) );
			if( pam_get_err(armno) )break;

//			LockMutex((long)armno);
			pa_map_ctl(armno);

			if(datatype)Tnum++;
			ldmy = (long)	Tnum;
			st=pa_cpy_lng(	(long)armno,&ldmy,&(_comuni->hu.ply.pnt.atr[0]),1);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			datatype = (short)	ldmy;
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.agl[0])	,&(_comuni->hu.ply.pnt.agl[0])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.agl[1])	,&(_comuni->hu.ply.pnt.agl[1])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.agl[2])	,&(_comuni->hu.ply.pnt.agl[2])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.agl[3])	,&(_comuni->hu.ply.pnt.agl[3])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.agl[4])	,&(_comuni->hu.ply.pnt.agl[4])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.agl[5])	,&(_comuni->hu.ply.pnt.agl[5])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.agl[6])	,&(_comuni->hu.ply.pnt.agl[6])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.vel[0])	,&(_comuni->hu.ply.pnt.vel[0])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_flt(	(long)armno,&(pntdat.ply.pnt.vel[1])	,&(_comuni->hu.ply.pnt.vel[1])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[0])	,&(_comuni->hu.ply.pnt.atr[0])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[1])	,&(_comuni->hu.ply.pnt.atr[1])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[2])	,&(_comuni->hu.ply.pnt.atr[2])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[3])	,&(_comuni->hu.ply.pnt.atr[3])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[4])	,&(_comuni->hu.ply.pnt.atr[4])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[5])	,&(_comuni->hu.ply.pnt.atr[5])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[6])	,&(_comuni->hu.ply.pnt.atr[6])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[7])	,&(_comuni->hu.ply.pnt.atr[7])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[8])	,&(_comuni->hu.ply.pnt.atr[8])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[9])	,&(_comuni->hu.ply.pnt.atr[9])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[10])	,&(_comuni->hu.ply.pnt.atr[10])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			st=pa_cpy_lng(	(long)armno,&(pntdat.ply.pnt.atr[11])	,&(_comuni->hu.ply.pnt.atr[11])	,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}

			st=pa_mem_blk(	(long)armno,cmt	,&(_comuni->hu.ply.cmt[0])	,(size_t)32,1	);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			cmt[32]='\0';

			afdmy=(float)(pntdat.ply.pnt.atr[7]&0x0000ffff)/10;
			rfdmy=(float)(pntdat.ply.pnt.atr[7]>>16&0x0000ffff)/10;
			
			fprintf(stream,"%d,%d,%s,%.3f,%.3f,%.3f,%.3f,%.3f,%.3f,%.3f,%.3f,%.3f,",
				pntdat.ply.pnt.atr[4],										/*ֹ̤*/
				pntdat.ply.pnt.atr[5],										/*ID*/
				cmt,														/**/
				RadToDeg(pntdat.ply.pnt.agl[0]),							/*S1*/
				RadToDeg(pntdat.ply.pnt.agl[1]),							/*S2*/
				RadToDeg(pntdat.ply.pnt.agl[2]),							/*S3*/
				RadToDeg(pntdat.ply.pnt.agl[3]),							/*E1*/
				RadToDeg(pntdat.ply.pnt.agl[4]),							/*E2*/
				RadToDeg(pntdat.ply.pnt.agl[5]),							/*W1*/
				RadToDeg(pntdat.ply.pnt.agl[6]),							/*W2*/
				pntdat.ply.pnt.vel[0],										/*®[mm/sec]*/
				RadToDeg(pntdat.ply.pnt.vel[1])								/*®[deg/sec]*/
			);
			if(pntdat.ply.pnt.atr[0]==1)		fprintf(stream,"PTP,");		/* PTP/PTP(NOAP)*/
			else if(pntdat.ply.pnt.atr[0]==2)	fprintf(stream,"NOAP,");
			if(pntdat.ply.pnt.atr[1]==21)		fprintf(stream,"EACH,");	/*ˡ ľ//߸*/
			else if(pntdat.ply.pnt.atr[1]==18)	fprintf(stream,"LINE,");
			else if(pntdat.ply.pnt.atr[1]==17)	fprintf(stream,"ARC,");
			else if(pntdat.ply.pnt.atr[1]==16)	fprintf(stream,"CIRCLE,");
			fprintf(stream,"%.1f,%.1f,",afdmy,rfdmy);						/*١ʳƼ*//*١RMRC*/
			if(pntdat.ply.pnt.atr[2]==0)		fprintf(stream,"Line,");	/*®٥*/
			else if(pntdat.ply.pnt.atr[2]==1)	fprintf(stream,"StartUp,");
			else if(pntdat.ply.pnt.atr[2]==2)	fprintf(stream,"ShutDown,");
			else if(pntdat.ply.pnt.atr[2]==3)	fprintf(stream,"Trap,");
			fprintf(stream,"%d,%d,%d,%x,%d",
				pntdat.ply.pnt.atr[9],										/*®[*0.01msec]*/
				pntdat.ply.pnt.atr[10],										/*®[*0.01msec]*/
				pntdat.ply.pnt.atr[8],										/*JUMPֹ*/
				pntdat.ply.pnt.atr[6],										/*DO16ʿ*/
				pntdat.ply.pnt.atr[3]										/*Ԥ[msec]*/
			);

			if(pntdat.ply.pnt.atr[0]==2){
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.xyz[0])	,&(_comuni->hu.noa.xyz[0])		,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.xyz[1])	,&(_comuni->hu.noa.xyz[1])		,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.xyz[2])	,&(_comuni->hu.noa.xyz[2])		,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[0][0]),&(_comuni->hu.noa.noa[0][0])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[0][1]),&(_comuni->hu.noa.noa[0][1])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[0][2]),&(_comuni->hu.noa.noa[0][2])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[1][0]),&(_comuni->hu.noa.noa[1][0])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[1][1]),&(_comuni->hu.noa.noa[1][1])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[1][2]),&(_comuni->hu.noa.noa[1][2])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[2][0]),&(_comuni->hu.noa.noa[2][0])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[2][1]),&(_comuni->hu.noa.noa[2][1])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				st=pa_cpy_flt(	(long)armno,&(pntdat.noa.noa[2][2]),&(_comuni->hu.noa.noa[2][2])	,1	);
				if(st<0){
					UnlockMutex((long)armno);
					return st;
				}
				fprintf(stream,",%.3f,%.3f,%.3f,%.6f,%.6f,%.6f,%.6f,%.6f,%.6f,%.6f,%.6f,%.6f\n",
					pntdat.noa.xyz[0],pntdat.noa.xyz[1],pntdat.noa.xyz[2],
					pntdat.noa.noa[0][0],pntdat.noa.noa[0][1],pntdat.noa.noa[0][2],
					pntdat.noa.noa[1][0],pntdat.noa.noa[1][1],pntdat.noa.noa[1][2],
					pntdat.noa.noa[2][0],pntdat.noa.noa[2][1],pntdat.noa.noa[2][2]);
			}
			else{
				fprintf(stream,",,,,,,,,,,,,\n");
			}

			st=pa_cpy_lng(	(long)armno,&ldmy,&(_comuni->hu.hed.dmy[0]),1);
			if(st<0){
				UnlockMutex((long)armno);
				return st;
			}
			if( ldmy == (long)'E' )flg=0;
//			UnlockMutex((long)armno);
		}
		UnlockMutex((long)armno);
		fclose(stream);
	}
	else		return ERR_FILE;

	return pam_get_err(armno);
}

/******************************************************************
	ץ쥤Хå®ٷ
			armno	-No.
			cof	ץ쥤Хå®ٷ( 0.09 < cof < 3.1 )

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
******************************************************************/
DllExport long  pa_vel_pnt(ARM armno, float cof)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	PBVelocityEvent;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	st=pa_cpy_flt(	(long)armno,&(_comuni->hd.dwn.fvl),&cof,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ߤζ˳Ƽư롣(ץ쥤ХåƼư)
			armno		No.
			wfp		ưδλޤԤĤɤλ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_axs_pnt(ARM armno, long wfp)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	PlayBackReadyEvent3;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	0x7f;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.axs),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	pam_exe_wfp(armno,wfp);
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ƥ֤ʶǡڴ
			armno		No.
			key		ǡKeyֹ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_act_pnt(ARM armno, long key)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_ACT_PNT;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	key;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ߥƥ֤ʶǡKeyѹ
			armno		No.
			key		ǡKeyֹ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_chg_key(ARM armno, long key)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_CHG_KEY;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	key;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dwn.lvl),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	ֹǶǡKey
			armno		No.
			number		ǡֹ
			*key		ǡKeyֹ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_ply_set(ARM armno, long number, long* key)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_PLY_SET;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	5;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	number;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.dmy[0]),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);

	if( ERR_OK==(st=pam_get_err(armno)) ){
		pa_map_ctl(armno);
		if(ERR_OK!=(st=pa_cpy_lng((long)armno,key,&(_comuni->hu.sts.lvl[1]),1)))	return st;
	}
	
	return pam_get_err(armno);
		
}

/******************************************************************
	ƥֶǡKey
			armno		No.
			*key		Keyֹ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_get_key(ARM armno, long* key)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,key,&(_comuni->hu.sts.lvl[0]),1)))	return st;

	return pam_get_err(armno);
}

/******************************************************************
	ǡ
			armno		No.
			cmt			

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long  pa_set_cmt(ARM armno, char* cmt)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	EV_SET_CMT;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	5;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return st;
	}

	cmt[32]='\0';
	if(strlen(cmt)<32){
		st=pa_mem_blk((long)armno,&(_comuni->hd.ply.cmt[0]),cmt,(size_t)(strlen(cmt)+1),2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}
	else{
		st=pa_mem_blk((long)armno,&(_comuni->hd.ply.cmt[0]),cmt,(size_t)32,2);
		if(st<0){
			UnlockMutex((long)armno);
			return st;
		}
	}
	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_chk(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}


/******************************************************************
	ȥʥץ쥤Хå֡ˤμ
			armno		No.
			tim		ȥ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long 	pa_tct_tim(ARM armno, long* tim)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )	return st;
	if(ERR_OK!=(st=pa_cpy_lng((long)armno,tim,&(_comuni->hu.sts.lvl[10]),1)))	return st;

	return pam_get_err(armno);

}
