
if { [info exist ::paQ7Speed] } {

} else {
    set ::paQ7Speed [ANGLE ::paQ7Speed]
    ANGLESet $::paQ7Speed 0 0 0  0 0 0  0
    #    puts "::paQ7Speed= [ANGLEGet $::paQ7Speed]"
}

# frequency of defining speed
set ::paSpeedUpdateDelay 100

if { [winfo exist .paSpeed] } { destroy .paSpeed }

toplevel .paSpeed
button .paSpeed.stopBreak -text "Stop (break)" -command pa_stop -background red

button .paSpeed.close -text Close -command { 
    paSpeedStop
    destroy .paSpeed
}

button .paSpeed.stop -text "Stop velocity control" -command { paSpeedStop }

proc paSpeedStop { } {
    paSpeedZero
    set ::paUpdateSpeedStop 1 
    after [expr 2 * $::paSpeedUpdateDelay]
    pa_sus_arm $::armNo $::WM_NOWAIT
}

button .paSpeed.zero -text "Reset sliders to 0" -command paSpeedZero

proc paSpeedZero { } {
    foreach el { s1 s2 e1 e2 w1 w2 } {
	.paSpeed.$el.s set 0.0
    }
}


# get the mode before...
#?? dangerous ?    set status [pa_odr_vel $::armNo $::paQ7Speed]
#    paErrorStatus pa_odr_vel $status


button .paSpeed.start -text "Start velocity control" -command paSpeedStart

proc paUpdateSpeed { } {
    set status [pa_odr_vel $::armNo [pa10ANGLE2float $::paQ7Speed] ]
    paErrorStatus pa_odr_vel $status
    if { $::paUpdateSpeedStop } { 
	return
    } else {
	after $::paSpeedUpdateDelay paUpdateSpeed
    }
}


proc paSpeedStart { } {
    ANGLESet $::paQ7Speed 0 0 0  0 0 0  0
    #pa_set_tim   en 10 ms  soit 20 correspond a 200 ms
    set status [pa_set_tim $::armNo 20]
    paErrorStatus pa_set_tim $status
    # Set velocity mode : 
    # VM_ONE is q axis velocity mode
    # VM_xyzypr is velocity mode in mechanical interface frame
    # VM_XYZYPR is velocity mode in base frame
    # last parameter not used in VM_xyzypr and VM_XYZYPR
    #set status [pa_mod_vel $::armNo VM_xyzypr 0
    set status [pa_mod_vel $::armNo $::VM_ONE [paAXISAllAxis] ]
    paErrorStatus pa_mod_vel $status
    set ::paUpdateSpeedStop 0
    paUpdateSpeed
}


foreach el { s1 s2 e1 e2 w1 w2 } {
    set f .paSpeed.$el
    frame $f
    label $f.l -text $el
    scale $f.s -length 200 -variable paQSpeed[set el] \
	-orient horizontal -resolution 0.01 -tickinterval 0 \
	-from -1. -to 1. -command "$::paQ7Speed configure -$el"
    eval pack [winfo children $f] -side left
}

#foreach el { s1 s2 e1 e2 w1 w2 } {
#    .$el.s configure -tickinterval \
#	[expr [.$el.s cget -to] - [.$el.s cget -from] - 0.009]
#}

eval pack [winfo children .paSpeed]
